const {
    writeRLE,
    drawTiles,
    flatLookup,
    drawRect,
    drawAttrs,
} = require('./nametables');

const legal = Array.from({ length: 1024 }, () => 0xFF);
const rocket = [...legal];

const lookup = flatLookup(`
0123456789ABCDEF
GHIJKLMNOPQRSTUV
WXYZ-.˙>qweadzxc
################
################
################
################
################
################
################
################
################
################
################
################
###############
`);

drawTiles(rocket, lookup, `
################################
################################
################################
################################
################################
################################
############          ##########
############  ROCKET  ##SCORE###
############  SCREEN  ##########
############          ##########
############          ##########
############          ##LINES###
############          ##########
############          ##########
############          ##########
############          ##LEVEL###
############          ##########
############          ##########
############          ##########
############          ##START###
############          ##########
############          ##########
############          ##########
############          ##########
############          ##########
############          ##########
################################
################################
################################
################################
`);

// drawRect(rocket, -2, 11, 9, 6, 0x30);

drawTiles(legal, lookup, `
################################
################################
################################
################################
################################
################################
################################
################################
################################
################################
################################
#########LEGAL  SCREEN##########
################################
################################
################################
################################
################################
################################
################################
################################
################################
################################
################################
######SOMETHING TO DO WITH######
########ALEXEY PAZHITNOV########
################################
################################
################################
################################
################################
`);

drawAttrs(rocket, [`
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
`,`
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
`]);

drawAttrs(legal, [`
    0000000000000000
    0000000000000000
    0000000000000000
    0000000000000000
    0000000000000000
    0000000000000000
    0000000000000000
    0000000000000000
`,`
    0000000000000000
    0000000000000000
    0000000000000000
    0000000000000000
    1111111111111111
    1111111111111111
    1111111111111111
    1111111111111111
`]);

writeRLE(
    __dirname + '/rocket_nametable.bin',
    rocket,
);

writeRLE(
    __dirname + '/legal_nametable.bin',
    legal,
);
